def define_beam_orient(mesh,info):
  '''defines the orientation of a beam.
     The orientation is defined by VECT_Y and depends here on 
     the coordinates of the connectivity nodes
     If info==2 additional information mesh information is printed'''


## ElemType[ii]==16 --> coque_3D or quad9
## ElemType[ii]==2  --> beam/.... or seg2

  from Utilitai.partition import *   # this import the MAIL_PY module
  import numpy
  import math

  ## define mesh quantities
  meshCA   = MAIL_PY()
  meshCA.FromAster(mesh);
  nonu     = meshCA.dime_maillage[0]
  elnu     = meshCA.dime_maillage[2]
  ncoord   = meshCA.cn
  connect  = meshCA.co
  NodeList = list(meshCA.correspondance_noeuds)
  ElemList = list(meshCA.correspondance_mailles)
  ElemType = list(meshCA.tm)

  if (info==2):
    print ['info set to %d - print some information.',info]
    print 'number of nodes in group: ',nonu
    print 'number of elements in group: ',elnu
    print 'node list: ',NodeList
    print 'element list: ',ElemList
    print 'element type list: ',ElemType
    print meshCA   ## complete mesh information

  # need to count number of shell elements (16: coque_3d) to initialise 'thickness list'
  BeamCount = 0
  for ii in xrange(len(ElemList)):
    if (info==2):
       print ElemType[ii]
       print connect[ii]
    if ElemType[ii]==2:  # select beam element (seg2)
      BeamCount +=1
      
  xmax = numpy.max(ncoord)
  print 'xmax: ',xmax
  OrientBeam=[]
  vy = [None]*BeamCount   # initialise VECT_Y
  BeamCount = 0
  for ii in xrange(len(ElemList)):
     print ' ' 
     if (info==2):
       print 'elementtype: ',ii,ElemType[ii]
     if ElemType[ii]==2:  # select seg1
       ncount = len(connect[ii])    # should be 9 for coque_3d (elementType 16)
       for jj in xrange(0,ncount):
         Gnode = connect[ii][jj]    # globalnode = connect[elemii,internal_nodejj]
         ###sumxyz += ncoord[Gnode]    # this might be written more compact --> for later
         print 'connectivity: ',Gnode
         print 'ncoord:       ',ncoord[Gnode]
       # define your own code for thickness here 
       # thickness now depends on average y coordinate only
       ##   ORIENTATION=(_F(GROUP_MA='beam1',
       ##                   CARA='VECT_Y',
       ##                   VALE=(0.0,0.0,1.0,),),),)
       #thickness[BeamCount] = sumxyz[1]*0.1+0.01  # make thickness depent on y coordinate
       #tempth = thickness[shellcount]
       ## change orientation of beams along x axis - mesh is along x axis
       phase = math.pi/2.0*ncoord[Gnode]/xmax
       #print 'gnode: ',Gnode
       print 'phase: ',phase
       y_vy = math.cos(phase)
       z_vy = math.sin(phase)
       #if phase>xmax/6: 
       #   y_vy = 1.0
       #   z_vy = 0.0
       #else:
       #   y_vy = 0.0
       #   z_vy = 1.0
          
       vy = [0.000000, y_vy, z_vy]
       OrientBeam.append({'CARA':'VECT_Y','VALE':vy,'MAILLE':'M%d'%(ii+1)});  ## add 1 for element number Mxx

       BeamCount +=1
       #print OrientBeam

  if (info==2):
    print 'OrientBeam: ',OrientBeam
    
  return OrientBeam

